diff --git a/src/backend/pipeline/cont_analyze.c b/src/backend/pipeline/cont_analyze.c
index 93c345101..828542e27 100644
--- a/src/backend/pipeline/cont_analyze.c
+++ b/src/backend/pipeline/cont_analyze.c
@@ -2433,27 +2433,46 @@ TransformSelectStmtForContProcess(RangeVar *mat_relation, SelectStmt *stmt, Sele
 	tmp_list = NIL;
 	for (i = 0; i < grp_len; i++)
 	{
-		Node *node = (Node *) list_nth(proc->groupClause, i);
-		ColumnRef *cref = hoist_node(&proc->targetList, node, context);
+		Node *group_node = (Node *) list_nth(proc->groupClause, i);
+		List *nodes;
+		ListCell *glc;
 
-		/*
-		 * For workers, don't add the hoisted column because it can lead to ambiguity, for example if
-		 * there is an id column in t for the query below:
-		 *   CREATE CONTINUOUS VIEW v AS SELECT s.id, t.str, sum(s.val + t.val) FROM s JOIN t ON s.id = t.id GROUP BY s.id;
-		 */
-		if (proc_type == Combiner)
-			tmp_list = lappend(tmp_list, cref);
+		if (IsA(group_node, GroupingSet))
+			nodes = ((GroupingSet *) group_node)->content;
 		else
-			tmp_list = lappend(tmp_list, node);
+			nodes = list_make1(group_node);
 
-		/*
-		 * If the view combines, then the view will have a GROUP BY equivalent to that
-		 * of the continuous query. The extra GROUP BY expression on the worker will be
-		 * aggregated over in the view. The view MUST always reference the hoisted column reference
-		 * of the matrel.
-		 */
-		if (context->view_combines)
-			view->groupClause = lappend(view->groupClause, cref);
+		foreach(glc, nodes)
+		{
+			Node *node = (Node *) lfirst(glc);
+			ColumnRef *cref = hoist_node(&proc->targetList, node, context);
+
+			/*
+			 * If the view combines, then the view will have a GROUP BY equivalent to that
+			 * of the continuous query. The extra GROUP BY expression on the worker will be
+			 * aggregated over in the view. The view MUST always reference the hoisted column reference
+			 * of the matrel.
+			 */
+			if (context->view_combines)
+				view->groupClause = lappend(view->groupClause, cref);
+
+			/* The entire grouping set will be added to the worker's group clause later */
+			if (IsA(group_node, GroupingSet) && proc_type == Worker)
+				continue;
+
+			/*
+			 * For workers, don't add the hoisted column because it can lead to ambiguity, for example if
+			 * there is an id column in t for the query below:
+			 *   CREATE CONTINUOUS VIEW v AS SELECT s.id, t.str, sum(s.val + t.val) FROM s JOIN t ON s.id = t.id GROUP BY s.id;
+			 */
+			if (proc_type == Combiner)
+				tmp_list = lappend(tmp_list, cref);
+			else
+				tmp_list = lappend(tmp_list, node);
+		}
+
+		if (IsA(group_node, GroupingSet) && proc_type == Worker)
+			tmp_list = lappend(tmp_list, group_node);
 	}
 
 	for (; i < list_length(proc->groupClause); i++)
diff --git a/src/backend/pipeline/cont_combiner.c b/src/backend/pipeline/cont_combiner.c
index fa015ad17..c61486d67 100644
--- a/src/backend/pipeline/cont_combiner.c
+++ b/src/backend/pipeline/cont_combiner.c
@@ -762,7 +762,7 @@ init_query_state(ContExecutor *cont_exec, ContQueryState *base)
 		ri = CQMatRelOpen(matrel);
 
 		if (state->ngroupatts)
-			state->hashfunc = GetGroupHashIndexExpr(state->ngroupatts, ri);
+			state->hashfunc = GetGroupHashIndexExpr(ri);
 
 		CQMatRelClose(ri);
 
diff --git a/src/backend/pipeline/cont_plan.c b/src/backend/pipeline/cont_plan.c
index 527132bf6..266dd1484 100644
--- a/src/backend/pipeline/cont_plan.c
+++ b/src/backend/pipeline/cont_plan.c
@@ -248,7 +248,7 @@ SetCombinerPlanTuplestorestate(PlannedStmt *plan, Tuplestorestate *tupstore)
  * Returns the function expression used to index the given matrel
  */
 FuncExpr *
-GetGroupHashIndexExpr(int group_len, ResultRelInfo *ri)
+GetGroupHashIndexExpr(ResultRelInfo *ri)
 {
 	FuncExpr *result = NULL;
 	int i;
@@ -272,8 +272,7 @@ GetGroupHashIndexExpr(int group_len, ResultRelInfo *ri)
 			continue;
 
 		func = (FuncExpr *) n;
-		if ((func->funcid != HASH_GROUP_OID && func->funcid != LS_HASH_GROUP_OID) ||
-				list_length(func->args) != group_len)
+		if (func->funcid != HASH_GROUP_OID && func->funcid != LS_HASH_GROUP_OID)
 			continue;
 
 		result = copyObject(func);
diff --git a/src/backend/pipeline/cont_worker.c b/src/backend/pipeline/cont_worker.c
index 3dea5aa6a..74ff7c16a 100644
--- a/src/backend/pipeline/cont_worker.c
+++ b/src/backend/pipeline/cont_worker.c
@@ -123,7 +123,7 @@ init_query_state(ContExecutor *exec, ContQueryState *base)
 
 		if (agg->numCols)
 		{
-			FuncExpr *hash = GetGroupHashIndexExpr(agg->numCols, ri);
+			FuncExpr *hash = GetGroupHashIndexExpr(ri);
 			if (hash == NULL)
 			{
 				/* matrel has been dropped */
diff --git a/src/include/pipeline/cont_plan.h b/src/include/pipeline/cont_plan.h
index 76784bbbb..736aa15cf 100644
--- a/src/include/pipeline/cont_plan.h
+++ b/src/include/pipeline/cont_plan.h
@@ -35,7 +35,7 @@ extern ProcessUtility_hook_type SaveUtilityHook;
 
 extern PlannedStmt *GetContPlan(ContinuousView *view, ContQueryProcType type);
 extern TuplestoreScan *SetCombinerPlanTuplestorestate(PlannedStmt *plan, Tuplestorestate *tupstore);
-extern FuncExpr *GetGroupHashIndexExpr(int group_len, ResultRelInfo *ri);
+extern FuncExpr *GetGroupHashIndexExpr(ResultRelInfo *ri);
 extern PlannedStmt *GetCombinerLookupPlan(ContinuousView *view);
 extern PlannedStmt *GetContinuousViewOverlayPlan(ContinuousView *view);
 
diff --git a/src/test/regress/expected/cont_grouping_sets.out b/src/test/regress/expected/cont_grouping_sets.out
new file mode 100644
index 000000000..705e1b546
--- /dev/null
+++ b/src/test/regress/expected/cont_grouping_sets.out
@@ -0,0 +1,1798 @@
+CREATE CONTINUOUS VIEW test_gs0 AS SELECT x::integer, y::integer, COUNT(*) FROM test_gs_stream
+	GROUP BY CUBE (x, y);
+SELECT pipeline_get_worker_querydef('test_gs0');
+      pipeline_get_worker_querydef       
+-----------------------------------------
+  SELECT x::integer,                    +
+     y::integer,                        +
+     count(*) AS count                  +
+    FROM ONLY test_gs_stream            +
+   GROUP BY CUBE(x::integer, y::integer)
+(1 row)
+
+SELECT pipeline_get_combiner_querydef('test_gs0');
+ pipeline_get_combiner_querydef 
+--------------------------------
+  SELECT x,                    +
+     y,                        +
+     combine(count) AS count   +
+    FROM test_gs0_mrel         +
+   GROUP BY x, y
+(1 row)
+
+SELECT pipeline_get_overlay_viewdef('test_gs0');
+ pipeline_get_overlay_viewdef 
+------------------------------
+  SELECT test_gs0_mrel.x,    +
+     test_gs0_mrel.y,        +
+     test_gs0_mrel.count     +
+    FROM test_gs0_mrel;
+(1 row)
+
+CREATE CONTINUOUS VIEW test_gs1 AS SELECT x::integer, y::integer, z::integer, COUNT(*) FROM test_gs_stream
+	GROUP BY GROUPING SETS (x), (x, y), (x, y, z), (x, z);
+SELECT pipeline_get_worker_querydef('test_gs1');
+         pipeline_get_worker_querydef          
+-----------------------------------------------
+  SELECT x::integer,                          +
+     y::integer,                              +
+     z::integer,                              +
+     count(*) AS count                        +
+    FROM ONLY test_gs_stream                  +
+   GROUP BY x::integer, y::integer, z::integer
+(1 row)
+
+SELECT pipeline_get_combiner_querydef('test_gs1');
+ pipeline_get_combiner_querydef 
+--------------------------------
+  SELECT x,                    +
+     y,                        +
+     z,                        +
+     combine(count) AS count   +
+    FROM test_gs1_mrel         +
+   GROUP BY x, y, z
+(1 row)
+
+SELECT pipeline_get_overlay_viewdef('test_gs1');
+ pipeline_get_overlay_viewdef 
+------------------------------
+  SELECT test_gs1_mrel.x,    +
+     test_gs1_mrel.y,        +
+     test_gs1_mrel.z,        +
+     test_gs1_mrel.count     +
+    FROM test_gs1_mrel;
+(1 row)
+
+CREATE CONTINUOUS VIEW test_gs2 AS SELECT x::integer, y::integer, COUNT(*) FROM test_gs_stream
+	GROUP BY GROUPING SETS (x), (x, y);
+SELECT pipeline_get_worker_querydef('test_gs2');
+   pipeline_get_worker_querydef    
+-----------------------------------
+  SELECT x::integer,              +
+     y::integer,                  +
+     count(*) AS count            +
+    FROM ONLY test_gs_stream      +
+   GROUP BY x::integer, y::integer
+(1 row)
+
+SELECT pipeline_get_combiner_querydef('test_gs2');
+ pipeline_get_combiner_querydef 
+--------------------------------
+  SELECT x,                    +
+     y,                        +
+     combine(count) AS count   +
+    FROM test_gs2_mrel         +
+   GROUP BY x, y
+(1 row)
+
+SELECT pipeline_get_overlay_viewdef('test_gs2');
+ pipeline_get_overlay_viewdef 
+------------------------------
+  SELECT test_gs2_mrel.x,    +
+     test_gs2_mrel.y,        +
+     test_gs2_mrel.count     +
+    FROM test_gs2_mrel;
+(1 row)
+
+CREATE CONTINUOUS VIEW test_gs3 WITH (max_age = '5 seconds') AS SELECT x::integer, y::integer, z::integer, COUNT(*) FROM test_gs_stream
+	GROUP BY GROUPING SETS (x, y, z);
+SELECT pipeline_get_worker_querydef('test_gs3');
+                                                            pipeline_get_worker_querydef                                                             
+-----------------------------------------------------------------------------------------------------------------------------------------------------
+  SELECT date_round(arrival_timestamp::timestamp with time zone, '@ 1 sec'::interval) AS arrival_timestamp,                                         +
+     x::integer,                                                                                                                                    +
+     y::integer,                                                                                                                                    +
+     z::integer,                                                                                                                                    +
+     count(*) AS count                                                                                                                              +
+    FROM ONLY test_gs_stream                                                                                                                        +
+   WHERE (arrival_timestamp::timestamp with time zone > (clock_timestamp() - '@ 5 secs'::interval))                                                 +
+   GROUP BY GROUPING SETS ((x::integer), (y::integer), (z::integer)), (date_round(arrival_timestamp::timestamp with time zone, '@ 1 sec'::interval))
+(1 row)
+
+SELECT pipeline_get_combiner_querydef('test_gs3');
+    pipeline_get_combiner_querydef     
+---------------------------------------
+  SELECT arrival_timestamp,           +
+     x,                               +
+     y,                               +
+     z,                               +
+     combine(count) AS count          +
+    FROM test_gs3_mrel                +
+   GROUP BY x, y, z, arrival_timestamp
+(1 row)
+
+SELECT pipeline_get_overlay_viewdef('test_gs3');
+                              pipeline_get_overlay_viewdef                              
+----------------------------------------------------------------------------------------
+  SELECT test_gs3_mrel.x,                                                              +
+     test_gs3_mrel.y,                                                                  +
+     test_gs3_mrel.z,                                                                  +
+     combine(test_gs3_mrel.count) AS count                                             +
+    FROM test_gs3_mrel                                                                 +
+   WHERE (test_gs3_mrel.arrival_timestamp > (clock_timestamp() - '@ 5 secs'::interval))+
+   GROUP BY test_gs3_mrel.x, test_gs3_mrel.y, test_gs3_mrel.z;
+(1 row)
+
+INSERT INTO test_gs_stream (x, y, z) SELECT x, x * 2 AS y, -x AS z FROM generate_series(1, 100) AS x;
+INSERT INTO test_gs_stream (x, y, z) SELECT x, x * 2 AS y, -x AS z FROM generate_series(1, 100) AS x;
+INSERT INTO test_gs_stream (x, y, z) SELECT x, x * 2 AS y, -x AS z FROM generate_series(1, 100) AS x;
+SELECT * FROM test_gs0 ORDER BY x, y;
+  x  |  y  | count 
+-----+-----+-------
+   1 |   2 |     3
+   1 |     |     3
+   2 |   4 |     3
+   2 |     |     3
+   3 |   6 |     3
+   3 |     |     3
+   4 |   8 |     3
+   4 |     |     3
+   5 |  10 |     3
+   5 |     |     3
+   6 |  12 |     3
+   6 |     |     3
+   7 |  14 |     3
+   7 |     |     3
+   8 |  16 |     3
+   8 |     |     3
+   9 |  18 |     3
+   9 |     |     3
+  10 |  20 |     3
+  10 |     |     3
+  11 |  22 |     3
+  11 |     |     3
+  12 |  24 |     3
+  12 |     |     3
+  13 |  26 |     3
+  13 |     |     3
+  14 |  28 |     3
+  14 |     |     3
+  15 |  30 |     3
+  15 |     |     3
+  16 |  32 |     3
+  16 |     |     3
+  17 |  34 |     3
+  17 |     |     3
+  18 |  36 |     3
+  18 |     |     3
+  19 |  38 |     3
+  19 |     |     3
+  20 |  40 |     3
+  20 |     |     3
+  21 |  42 |     3
+  21 |     |     3
+  22 |  44 |     3
+  22 |     |     3
+  23 |  46 |     3
+  23 |     |     3
+  24 |  48 |     3
+  24 |     |     3
+  25 |  50 |     3
+  25 |     |     3
+  26 |  52 |     3
+  26 |     |     3
+  27 |  54 |     3
+  27 |     |     3
+  28 |  56 |     3
+  28 |     |     3
+  29 |  58 |     3
+  29 |     |     3
+  30 |  60 |     3
+  30 |     |     3
+  31 |  62 |     3
+  31 |     |     3
+  32 |  64 |     3
+  32 |     |     3
+  33 |  66 |     3
+  33 |     |     3
+  34 |  68 |     3
+  34 |     |     3
+  35 |  70 |     3
+  35 |     |     3
+  36 |  72 |     3
+  36 |     |     3
+  37 |  74 |     3
+  37 |     |     3
+  38 |  76 |     3
+  38 |     |     3
+  39 |  78 |     3
+  39 |     |     3
+  40 |  80 |     3
+  40 |     |     3
+  41 |  82 |     3
+  41 |     |     3
+  42 |  84 |     3
+  42 |     |     3
+  43 |  86 |     3
+  43 |     |     3
+  44 |  88 |     3
+  44 |     |     3
+  45 |  90 |     3
+  45 |     |     3
+  46 |  92 |     3
+  46 |     |     3
+  47 |  94 |     3
+  47 |     |     3
+  48 |  96 |     3
+  48 |     |     3
+  49 |  98 |     3
+  49 |     |     3
+  50 | 100 |     3
+  50 |     |     3
+  51 | 102 |     3
+  51 |     |     3
+  52 | 104 |     3
+  52 |     |     3
+  53 | 106 |     3
+  53 |     |     3
+  54 | 108 |     3
+  54 |     |     3
+  55 | 110 |     3
+  55 |     |     3
+  56 | 112 |     3
+  56 |     |     3
+  57 | 114 |     3
+  57 |     |     3
+  58 | 116 |     3
+  58 |     |     3
+  59 | 118 |     3
+  59 |     |     3
+  60 | 120 |     3
+  60 |     |     3
+  61 | 122 |     3
+  61 |     |     3
+  62 | 124 |     3
+  62 |     |     3
+  63 | 126 |     3
+  63 |     |     3
+  64 | 128 |     3
+  64 |     |     3
+  65 | 130 |     3
+  65 |     |     3
+  66 | 132 |     3
+  66 |     |     3
+  67 | 134 |     3
+  67 |     |     3
+  68 | 136 |     3
+  68 |     |     3
+  69 | 138 |     3
+  69 |     |     3
+  70 | 140 |     3
+  70 |     |     3
+  71 | 142 |     3
+  71 |     |     3
+  72 | 144 |     3
+  72 |     |     3
+  73 | 146 |     3
+  73 |     |     3
+  74 | 148 |     3
+  74 |     |     3
+  75 | 150 |     3
+  75 |     |     3
+  76 | 152 |     3
+  76 |     |     3
+  77 | 154 |     3
+  77 |     |     3
+  78 | 156 |     3
+  78 |     |     3
+  79 | 158 |     3
+  79 |     |     3
+  80 | 160 |     3
+  80 |     |     3
+  81 | 162 |     3
+  81 |     |     3
+  82 | 164 |     3
+  82 |     |     3
+  83 | 166 |     3
+  83 |     |     3
+  84 | 168 |     3
+  84 |     |     3
+  85 | 170 |     3
+  85 |     |     3
+  86 | 172 |     3
+  86 |     |     3
+  87 | 174 |     3
+  87 |     |     3
+  88 | 176 |     3
+  88 |     |     3
+  89 | 178 |     3
+  89 |     |     3
+  90 | 180 |     3
+  90 |     |     3
+  91 | 182 |     3
+  91 |     |     3
+  92 | 184 |     3
+  92 |     |     3
+  93 | 186 |     3
+  93 |     |     3
+  94 | 188 |     3
+  94 |     |     3
+  95 | 190 |     3
+  95 |     |     3
+  96 | 192 |     3
+  96 |     |     3
+  97 | 194 |     3
+  97 |     |     3
+  98 | 196 |     3
+  98 |     |     3
+  99 | 198 |     3
+  99 |     |     3
+ 100 | 200 |     3
+ 100 |     |     3
+     |   2 |     3
+     |   4 |     3
+     |   6 |     3
+     |   8 |     3
+     |  10 |     3
+     |  12 |     3
+     |  14 |     3
+     |  16 |     3
+     |  18 |     3
+     |  20 |     3
+     |  22 |     3
+     |  24 |     3
+     |  26 |     3
+     |  28 |     3
+     |  30 |     3
+     |  32 |     3
+     |  34 |     3
+     |  36 |     3
+     |  38 |     3
+     |  40 |     3
+     |  42 |     3
+     |  44 |     3
+     |  46 |     3
+     |  48 |     3
+     |  50 |     3
+     |  52 |     3
+     |  54 |     3
+     |  56 |     3
+     |  58 |     3
+     |  60 |     3
+     |  62 |     3
+     |  64 |     3
+     |  66 |     3
+     |  68 |     3
+     |  70 |     3
+     |  72 |     3
+     |  74 |     3
+     |  76 |     3
+     |  78 |     3
+     |  80 |     3
+     |  82 |     3
+     |  84 |     3
+     |  86 |     3
+     |  88 |     3
+     |  90 |     3
+     |  92 |     3
+     |  94 |     3
+     |  96 |     3
+     |  98 |     3
+     | 100 |     3
+     | 102 |     3
+     | 104 |     3
+     | 106 |     3
+     | 108 |     3
+     | 110 |     3
+     | 112 |     3
+     | 114 |     3
+     | 116 |     3
+     | 118 |     3
+     | 120 |     3
+     | 122 |     3
+     | 124 |     3
+     | 126 |     3
+     | 128 |     3
+     | 130 |     3
+     | 132 |     3
+     | 134 |     3
+     | 136 |     3
+     | 138 |     3
+     | 140 |     3
+     | 142 |     3
+     | 144 |     3
+     | 146 |     3
+     | 148 |     3
+     | 150 |     3
+     | 152 |     3
+     | 154 |     3
+     | 156 |     3
+     | 158 |     3
+     | 160 |     3
+     | 162 |     3
+     | 164 |     3
+     | 166 |     3
+     | 168 |     3
+     | 170 |     3
+     | 172 |     3
+     | 174 |     3
+     | 176 |     3
+     | 178 |     3
+     | 180 |     3
+     | 182 |     3
+     | 184 |     3
+     | 186 |     3
+     | 188 |     3
+     | 190 |     3
+     | 192 |     3
+     | 194 |     3
+     | 196 |     3
+     | 198 |     3
+     | 200 |     3
+     |     |   300
+(301 rows)
+
+SELECT * FROM test_gs1 ORDER BY x, y, z;
+  x  |  y  |  z   | count 
+-----+-----+------+-------
+   1 |   2 |   -1 |     3
+   2 |   4 |   -2 |     3
+   3 |   6 |   -3 |     3
+   4 |   8 |   -4 |     3
+   5 |  10 |   -5 |     3
+   6 |  12 |   -6 |     3
+   7 |  14 |   -7 |     3
+   8 |  16 |   -8 |     3
+   9 |  18 |   -9 |     3
+  10 |  20 |  -10 |     3
+  11 |  22 |  -11 |     3
+  12 |  24 |  -12 |     3
+  13 |  26 |  -13 |     3
+  14 |  28 |  -14 |     3
+  15 |  30 |  -15 |     3
+  16 |  32 |  -16 |     3
+  17 |  34 |  -17 |     3
+  18 |  36 |  -18 |     3
+  19 |  38 |  -19 |     3
+  20 |  40 |  -20 |     3
+  21 |  42 |  -21 |     3
+  22 |  44 |  -22 |     3
+  23 |  46 |  -23 |     3
+  24 |  48 |  -24 |     3
+  25 |  50 |  -25 |     3
+  26 |  52 |  -26 |     3
+  27 |  54 |  -27 |     3
+  28 |  56 |  -28 |     3
+  29 |  58 |  -29 |     3
+  30 |  60 |  -30 |     3
+  31 |  62 |  -31 |     3
+  32 |  64 |  -32 |     3
+  33 |  66 |  -33 |     3
+  34 |  68 |  -34 |     3
+  35 |  70 |  -35 |     3
+  36 |  72 |  -36 |     3
+  37 |  74 |  -37 |     3
+  38 |  76 |  -38 |     3
+  39 |  78 |  -39 |     3
+  40 |  80 |  -40 |     3
+  41 |  82 |  -41 |     3
+  42 |  84 |  -42 |     3
+  43 |  86 |  -43 |     3
+  44 |  88 |  -44 |     3
+  45 |  90 |  -45 |     3
+  46 |  92 |  -46 |     3
+  47 |  94 |  -47 |     3
+  48 |  96 |  -48 |     3
+  49 |  98 |  -49 |     3
+  50 | 100 |  -50 |     3
+  51 | 102 |  -51 |     3
+  52 | 104 |  -52 |     3
+  53 | 106 |  -53 |     3
+  54 | 108 |  -54 |     3
+  55 | 110 |  -55 |     3
+  56 | 112 |  -56 |     3
+  57 | 114 |  -57 |     3
+  58 | 116 |  -58 |     3
+  59 | 118 |  -59 |     3
+  60 | 120 |  -60 |     3
+  61 | 122 |  -61 |     3
+  62 | 124 |  -62 |     3
+  63 | 126 |  -63 |     3
+  64 | 128 |  -64 |     3
+  65 | 130 |  -65 |     3
+  66 | 132 |  -66 |     3
+  67 | 134 |  -67 |     3
+  68 | 136 |  -68 |     3
+  69 | 138 |  -69 |     3
+  70 | 140 |  -70 |     3
+  71 | 142 |  -71 |     3
+  72 | 144 |  -72 |     3
+  73 | 146 |  -73 |     3
+  74 | 148 |  -74 |     3
+  75 | 150 |  -75 |     3
+  76 | 152 |  -76 |     3
+  77 | 154 |  -77 |     3
+  78 | 156 |  -78 |     3
+  79 | 158 |  -79 |     3
+  80 | 160 |  -80 |     3
+  81 | 162 |  -81 |     3
+  82 | 164 |  -82 |     3
+  83 | 166 |  -83 |     3
+  84 | 168 |  -84 |     3
+  85 | 170 |  -85 |     3
+  86 | 172 |  -86 |     3
+  87 | 174 |  -87 |     3
+  88 | 176 |  -88 |     3
+  89 | 178 |  -89 |     3
+  90 | 180 |  -90 |     3
+  91 | 182 |  -91 |     3
+  92 | 184 |  -92 |     3
+  93 | 186 |  -93 |     3
+  94 | 188 |  -94 |     3
+  95 | 190 |  -95 |     3
+  96 | 192 |  -96 |     3
+  97 | 194 |  -97 |     3
+  98 | 196 |  -98 |     3
+  99 | 198 |  -99 |     3
+ 100 | 200 | -100 |     3
+(100 rows)
+
+SELECT * FROM test_gs2 ORDER BY x, y;
+  x  |  y  | count 
+-----+-----+-------
+   1 |   2 |     3
+   2 |   4 |     3
+   3 |   6 |     3
+   4 |   8 |     3
+   5 |  10 |     3
+   6 |  12 |     3
+   7 |  14 |     3
+   8 |  16 |     3
+   9 |  18 |     3
+  10 |  20 |     3
+  11 |  22 |     3
+  12 |  24 |     3
+  13 |  26 |     3
+  14 |  28 |     3
+  15 |  30 |     3
+  16 |  32 |     3
+  17 |  34 |     3
+  18 |  36 |     3
+  19 |  38 |     3
+  20 |  40 |     3
+  21 |  42 |     3
+  22 |  44 |     3
+  23 |  46 |     3
+  24 |  48 |     3
+  25 |  50 |     3
+  26 |  52 |     3
+  27 |  54 |     3
+  28 |  56 |     3
+  29 |  58 |     3
+  30 |  60 |     3
+  31 |  62 |     3
+  32 |  64 |     3
+  33 |  66 |     3
+  34 |  68 |     3
+  35 |  70 |     3
+  36 |  72 |     3
+  37 |  74 |     3
+  38 |  76 |     3
+  39 |  78 |     3
+  40 |  80 |     3
+  41 |  82 |     3
+  42 |  84 |     3
+  43 |  86 |     3
+  44 |  88 |     3
+  45 |  90 |     3
+  46 |  92 |     3
+  47 |  94 |     3
+  48 |  96 |     3
+  49 |  98 |     3
+  50 | 100 |     3
+  51 | 102 |     3
+  52 | 104 |     3
+  53 | 106 |     3
+  54 | 108 |     3
+  55 | 110 |     3
+  56 | 112 |     3
+  57 | 114 |     3
+  58 | 116 |     3
+  59 | 118 |     3
+  60 | 120 |     3
+  61 | 122 |     3
+  62 | 124 |     3
+  63 | 126 |     3
+  64 | 128 |     3
+  65 | 130 |     3
+  66 | 132 |     3
+  67 | 134 |     3
+  68 | 136 |     3
+  69 | 138 |     3
+  70 | 140 |     3
+  71 | 142 |     3
+  72 | 144 |     3
+  73 | 146 |     3
+  74 | 148 |     3
+  75 | 150 |     3
+  76 | 152 |     3
+  77 | 154 |     3
+  78 | 156 |     3
+  79 | 158 |     3
+  80 | 160 |     3
+  81 | 162 |     3
+  82 | 164 |     3
+  83 | 166 |     3
+  84 | 168 |     3
+  85 | 170 |     3
+  86 | 172 |     3
+  87 | 174 |     3
+  88 | 176 |     3
+  89 | 178 |     3
+  90 | 180 |     3
+  91 | 182 |     3
+  92 | 184 |     3
+  93 | 186 |     3
+  94 | 188 |     3
+  95 | 190 |     3
+  96 | 192 |     3
+  97 | 194 |     3
+  98 | 196 |     3
+  99 | 198 |     3
+ 100 | 200 |     3
+(100 rows)
+
+SELECT * FROM test_gs3 ORDER BY x, y, z;
+  x  |  y  |  z   | count 
+-----+-----+------+-------
+   1 |     |      |     3
+   2 |     |      |     3
+   3 |     |      |     3
+   4 |     |      |     3
+   5 |     |      |     3
+   6 |     |      |     3
+   7 |     |      |     3
+   8 |     |      |     3
+   9 |     |      |     3
+  10 |     |      |     3
+  11 |     |      |     3
+  12 |     |      |     3
+  13 |     |      |     3
+  14 |     |      |     3
+  15 |     |      |     3
+  16 |     |      |     3
+  17 |     |      |     3
+  18 |     |      |     3
+  19 |     |      |     3
+  20 |     |      |     3
+  21 |     |      |     3
+  22 |     |      |     3
+  23 |     |      |     3
+  24 |     |      |     3
+  25 |     |      |     3
+  26 |     |      |     3
+  27 |     |      |     3
+  28 |     |      |     3
+  29 |     |      |     3
+  30 |     |      |     3
+  31 |     |      |     3
+  32 |     |      |     3
+  33 |     |      |     3
+  34 |     |      |     3
+  35 |     |      |     3
+  36 |     |      |     3
+  37 |     |      |     3
+  38 |     |      |     3
+  39 |     |      |     3
+  40 |     |      |     3
+  41 |     |      |     3
+  42 |     |      |     3
+  43 |     |      |     3
+  44 |     |      |     3
+  45 |     |      |     3
+  46 |     |      |     3
+  47 |     |      |     3
+  48 |     |      |     3
+  49 |     |      |     3
+  50 |     |      |     3
+  51 |     |      |     3
+  52 |     |      |     3
+  53 |     |      |     3
+  54 |     |      |     3
+  55 |     |      |     3
+  56 |     |      |     3
+  57 |     |      |     3
+  58 |     |      |     3
+  59 |     |      |     3
+  60 |     |      |     3
+  61 |     |      |     3
+  62 |     |      |     3
+  63 |     |      |     3
+  64 |     |      |     3
+  65 |     |      |     3
+  66 |     |      |     3
+  67 |     |      |     3
+  68 |     |      |     3
+  69 |     |      |     3
+  70 |     |      |     3
+  71 |     |      |     3
+  72 |     |      |     3
+  73 |     |      |     3
+  74 |     |      |     3
+  75 |     |      |     3
+  76 |     |      |     3
+  77 |     |      |     3
+  78 |     |      |     3
+  79 |     |      |     3
+  80 |     |      |     3
+  81 |     |      |     3
+  82 |     |      |     3
+  83 |     |      |     3
+  84 |     |      |     3
+  85 |     |      |     3
+  86 |     |      |     3
+  87 |     |      |     3
+  88 |     |      |     3
+  89 |     |      |     3
+  90 |     |      |     3
+  91 |     |      |     3
+  92 |     |      |     3
+  93 |     |      |     3
+  94 |     |      |     3
+  95 |     |      |     3
+  96 |     |      |     3
+  97 |     |      |     3
+  98 |     |      |     3
+  99 |     |      |     3
+ 100 |     |      |     3
+     |   2 |      |     3
+     |   4 |      |     3
+     |   6 |      |     3
+     |   8 |      |     3
+     |  10 |      |     3
+     |  12 |      |     3
+     |  14 |      |     3
+     |  16 |      |     3
+     |  18 |      |     3
+     |  20 |      |     3
+     |  22 |      |     3
+     |  24 |      |     3
+     |  26 |      |     3
+     |  28 |      |     3
+     |  30 |      |     3
+     |  32 |      |     3
+     |  34 |      |     3
+     |  36 |      |     3
+     |  38 |      |     3
+     |  40 |      |     3
+     |  42 |      |     3
+     |  44 |      |     3
+     |  46 |      |     3
+     |  48 |      |     3
+     |  50 |      |     3
+     |  52 |      |     3
+     |  54 |      |     3
+     |  56 |      |     3
+     |  58 |      |     3
+     |  60 |      |     3
+     |  62 |      |     3
+     |  64 |      |     3
+     |  66 |      |     3
+     |  68 |      |     3
+     |  70 |      |     3
+     |  72 |      |     3
+     |  74 |      |     3
+     |  76 |      |     3
+     |  78 |      |     3
+     |  80 |      |     3
+     |  82 |      |     3
+     |  84 |      |     3
+     |  86 |      |     3
+     |  88 |      |     3
+     |  90 |      |     3
+     |  92 |      |     3
+     |  94 |      |     3
+     |  96 |      |     3
+     |  98 |      |     3
+     | 100 |      |     3
+     | 102 |      |     3
+     | 104 |      |     3
+     | 106 |      |     3
+     | 108 |      |     3
+     | 110 |      |     3
+     | 112 |      |     3
+     | 114 |      |     3
+     | 116 |      |     3
+     | 118 |      |     3
+     | 120 |      |     3
+     | 122 |      |     3
+     | 124 |      |     3
+     | 126 |      |     3
+     | 128 |      |     3
+     | 130 |      |     3
+     | 132 |      |     3
+     | 134 |      |     3
+     | 136 |      |     3
+     | 138 |      |     3
+     | 140 |      |     3
+     | 142 |      |     3
+     | 144 |      |     3
+     | 146 |      |     3
+     | 148 |      |     3
+     | 150 |      |     3
+     | 152 |      |     3
+     | 154 |      |     3
+     | 156 |      |     3
+     | 158 |      |     3
+     | 160 |      |     3
+     | 162 |      |     3
+     | 164 |      |     3
+     | 166 |      |     3
+     | 168 |      |     3
+     | 170 |      |     3
+     | 172 |      |     3
+     | 174 |      |     3
+     | 176 |      |     3
+     | 178 |      |     3
+     | 180 |      |     3
+     | 182 |      |     3
+     | 184 |      |     3
+     | 186 |      |     3
+     | 188 |      |     3
+     | 190 |      |     3
+     | 192 |      |     3
+     | 194 |      |     3
+     | 196 |      |     3
+     | 198 |      |     3
+     | 200 |      |     3
+     |     | -100 |     3
+     |     |  -99 |     3
+     |     |  -98 |     3
+     |     |  -97 |     3
+     |     |  -96 |     3
+     |     |  -95 |     3
+     |     |  -94 |     3
+     |     |  -93 |     3
+     |     |  -92 |     3
+     |     |  -91 |     3
+     |     |  -90 |     3
+     |     |  -89 |     3
+     |     |  -88 |     3
+     |     |  -87 |     3
+     |     |  -86 |     3
+     |     |  -85 |     3
+     |     |  -84 |     3
+     |     |  -83 |     3
+     |     |  -82 |     3
+     |     |  -81 |     3
+     |     |  -80 |     3
+     |     |  -79 |     3
+     |     |  -78 |     3
+     |     |  -77 |     3
+     |     |  -76 |     3
+     |     |  -75 |     3
+     |     |  -74 |     3
+     |     |  -73 |     3
+     |     |  -72 |     3
+     |     |  -71 |     3
+     |     |  -70 |     3
+     |     |  -69 |     3
+     |     |  -68 |     3
+     |     |  -67 |     3
+     |     |  -66 |     3
+     |     |  -65 |     3
+     |     |  -64 |     3
+     |     |  -63 |     3
+     |     |  -62 |     3
+     |     |  -61 |     3
+     |     |  -60 |     3
+     |     |  -59 |     3
+     |     |  -58 |     3
+     |     |  -57 |     3
+     |     |  -56 |     3
+     |     |  -55 |     3
+     |     |  -54 |     3
+     |     |  -53 |     3
+     |     |  -52 |     3
+     |     |  -51 |     3
+     |     |  -50 |     3
+     |     |  -49 |     3
+     |     |  -48 |     3
+     |     |  -47 |     3
+     |     |  -46 |     3
+     |     |  -45 |     3
+     |     |  -44 |     3
+     |     |  -43 |     3
+     |     |  -42 |     3
+     |     |  -41 |     3
+     |     |  -40 |     3
+     |     |  -39 |     3
+     |     |  -38 |     3
+     |     |  -37 |     3
+     |     |  -36 |     3
+     |     |  -35 |     3
+     |     |  -34 |     3
+     |     |  -33 |     3
+     |     |  -32 |     3
+     |     |  -31 |     3
+     |     |  -30 |     3
+     |     |  -29 |     3
+     |     |  -28 |     3
+     |     |  -27 |     3
+     |     |  -26 |     3
+     |     |  -25 |     3
+     |     |  -24 |     3
+     |     |  -23 |     3
+     |     |  -22 |     3
+     |     |  -21 |     3
+     |     |  -20 |     3
+     |     |  -19 |     3
+     |     |  -18 |     3
+     |     |  -17 |     3
+     |     |  -16 |     3
+     |     |  -15 |     3
+     |     |  -14 |     3
+     |     |  -13 |     3
+     |     |  -12 |     3
+     |     |  -11 |     3
+     |     |  -10 |     3
+     |     |   -9 |     3
+     |     |   -8 |     3
+     |     |   -7 |     3
+     |     |   -6 |     3
+     |     |   -5 |     3
+     |     |   -4 |     3
+     |     |   -3 |     3
+     |     |   -2 |     3
+     |     |   -1 |     3
+(300 rows)
+
+INSERT INTO test_gs_stream (x, y, z) SELECT x, x * 2 AS y, -x AS z FROM generate_series(1, 100) AS x;
+INSERT INTO test_gs_stream (x, y, z) SELECT x, x * 2 AS y, -x AS z FROM generate_series(1, 100) AS x;
+INSERT INTO test_gs_stream (x, y, z) SELECT x, x * 2 AS y, -x AS z FROM generate_series(1, 100) AS x;
+SELECT * FROM test_gs0 ORDER BY x, y;
+  x  |  y  | count 
+-----+-----+-------
+   1 |   2 |     6
+   1 |     |     6
+   2 |   4 |     6
+   2 |     |     6
+   3 |   6 |     6
+   3 |     |     6
+   4 |   8 |     6
+   4 |     |     6
+   5 |  10 |     6
+   5 |     |     6
+   6 |  12 |     6
+   6 |     |     6
+   7 |  14 |     6
+   7 |     |     6
+   8 |  16 |     6
+   8 |     |     6
+   9 |  18 |     6
+   9 |     |     6
+  10 |  20 |     6
+  10 |     |     6
+  11 |  22 |     6
+  11 |     |     6
+  12 |  24 |     6
+  12 |     |     6
+  13 |  26 |     6
+  13 |     |     6
+  14 |  28 |     6
+  14 |     |     6
+  15 |  30 |     6
+  15 |     |     6
+  16 |  32 |     6
+  16 |     |     6
+  17 |  34 |     6
+  17 |     |     6
+  18 |  36 |     6
+  18 |     |     6
+  19 |  38 |     6
+  19 |     |     6
+  20 |  40 |     6
+  20 |     |     6
+  21 |  42 |     6
+  21 |     |     6
+  22 |  44 |     6
+  22 |     |     6
+  23 |  46 |     6
+  23 |     |     6
+  24 |  48 |     6
+  24 |     |     6
+  25 |  50 |     6
+  25 |     |     6
+  26 |  52 |     6
+  26 |     |     6
+  27 |  54 |     6
+  27 |     |     6
+  28 |  56 |     6
+  28 |     |     6
+  29 |  58 |     6
+  29 |     |     6
+  30 |  60 |     6
+  30 |     |     6
+  31 |  62 |     6
+  31 |     |     6
+  32 |  64 |     6
+  32 |     |     6
+  33 |  66 |     6
+  33 |     |     6
+  34 |  68 |     6
+  34 |     |     6
+  35 |  70 |     6
+  35 |     |     6
+  36 |  72 |     6
+  36 |     |     6
+  37 |  74 |     6
+  37 |     |     6
+  38 |  76 |     6
+  38 |     |     6
+  39 |  78 |     6
+  39 |     |     6
+  40 |  80 |     6
+  40 |     |     6
+  41 |  82 |     6
+  41 |     |     6
+  42 |  84 |     6
+  42 |     |     6
+  43 |  86 |     6
+  43 |     |     6
+  44 |  88 |     6
+  44 |     |     6
+  45 |  90 |     6
+  45 |     |     6
+  46 |  92 |     6
+  46 |     |     6
+  47 |  94 |     6
+  47 |     |     6
+  48 |  96 |     6
+  48 |     |     6
+  49 |  98 |     6
+  49 |     |     6
+  50 | 100 |     6
+  50 |     |     6
+  51 | 102 |     6
+  51 |     |     6
+  52 | 104 |     6
+  52 |     |     6
+  53 | 106 |     6
+  53 |     |     6
+  54 | 108 |     6
+  54 |     |     6
+  55 | 110 |     6
+  55 |     |     6
+  56 | 112 |     6
+  56 |     |     6
+  57 | 114 |     6
+  57 |     |     6
+  58 | 116 |     6
+  58 |     |     6
+  59 | 118 |     6
+  59 |     |     6
+  60 | 120 |     6
+  60 |     |     6
+  61 | 122 |     6
+  61 |     |     6
+  62 | 124 |     6
+  62 |     |     6
+  63 | 126 |     6
+  63 |     |     6
+  64 | 128 |     6
+  64 |     |     6
+  65 | 130 |     6
+  65 |     |     6
+  66 | 132 |     6
+  66 |     |     6
+  67 | 134 |     6
+  67 |     |     6
+  68 | 136 |     6
+  68 |     |     6
+  69 | 138 |     6
+  69 |     |     6
+  70 | 140 |     6
+  70 |     |     6
+  71 | 142 |     6
+  71 |     |     6
+  72 | 144 |     6
+  72 |     |     6
+  73 | 146 |     6
+  73 |     |     6
+  74 | 148 |     6
+  74 |     |     6
+  75 | 150 |     6
+  75 |     |     6
+  76 | 152 |     6
+  76 |     |     6
+  77 | 154 |     6
+  77 |     |     6
+  78 | 156 |     6
+  78 |     |     6
+  79 | 158 |     6
+  79 |     |     6
+  80 | 160 |     6
+  80 |     |     6
+  81 | 162 |     6
+  81 |     |     6
+  82 | 164 |     6
+  82 |     |     6
+  83 | 166 |     6
+  83 |     |     6
+  84 | 168 |     6
+  84 |     |     6
+  85 | 170 |     6
+  85 |     |     6
+  86 | 172 |     6
+  86 |     |     6
+  87 | 174 |     6
+  87 |     |     6
+  88 | 176 |     6
+  88 |     |     6
+  89 | 178 |     6
+  89 |     |     6
+  90 | 180 |     6
+  90 |     |     6
+  91 | 182 |     6
+  91 |     |     6
+  92 | 184 |     6
+  92 |     |     6
+  93 | 186 |     6
+  93 |     |     6
+  94 | 188 |     6
+  94 |     |     6
+  95 | 190 |     6
+  95 |     |     6
+  96 | 192 |     6
+  96 |     |     6
+  97 | 194 |     6
+  97 |     |     6
+  98 | 196 |     6
+  98 |     |     6
+  99 | 198 |     6
+  99 |     |     6
+ 100 | 200 |     6
+ 100 |     |     6
+     |   2 |     6
+     |   4 |     6
+     |   6 |     6
+     |   8 |     6
+     |  10 |     6
+     |  12 |     6
+     |  14 |     6
+     |  16 |     6
+     |  18 |     6
+     |  20 |     6
+     |  22 |     6
+     |  24 |     6
+     |  26 |     6
+     |  28 |     6
+     |  30 |     6
+     |  32 |     6
+     |  34 |     6
+     |  36 |     6
+     |  38 |     6
+     |  40 |     6
+     |  42 |     6
+     |  44 |     6
+     |  46 |     6
+     |  48 |     6
+     |  50 |     6
+     |  52 |     6
+     |  54 |     6
+     |  56 |     6
+     |  58 |     6
+     |  60 |     6
+     |  62 |     6
+     |  64 |     6
+     |  66 |     6
+     |  68 |     6
+     |  70 |     6
+     |  72 |     6
+     |  74 |     6
+     |  76 |     6
+     |  78 |     6
+     |  80 |     6
+     |  82 |     6
+     |  84 |     6
+     |  86 |     6
+     |  88 |     6
+     |  90 |     6
+     |  92 |     6
+     |  94 |     6
+     |  96 |     6
+     |  98 |     6
+     | 100 |     6
+     | 102 |     6
+     | 104 |     6
+     | 106 |     6
+     | 108 |     6
+     | 110 |     6
+     | 112 |     6
+     | 114 |     6
+     | 116 |     6
+     | 118 |     6
+     | 120 |     6
+     | 122 |     6
+     | 124 |     6
+     | 126 |     6
+     | 128 |     6
+     | 130 |     6
+     | 132 |     6
+     | 134 |     6
+     | 136 |     6
+     | 138 |     6
+     | 140 |     6
+     | 142 |     6
+     | 144 |     6
+     | 146 |     6
+     | 148 |     6
+     | 150 |     6
+     | 152 |     6
+     | 154 |     6
+     | 156 |     6
+     | 158 |     6
+     | 160 |     6
+     | 162 |     6
+     | 164 |     6
+     | 166 |     6
+     | 168 |     6
+     | 170 |     6
+     | 172 |     6
+     | 174 |     6
+     | 176 |     6
+     | 178 |     6
+     | 180 |     6
+     | 182 |     6
+     | 184 |     6
+     | 186 |     6
+     | 188 |     6
+     | 190 |     6
+     | 192 |     6
+     | 194 |     6
+     | 196 |     6
+     | 198 |     6
+     | 200 |     6
+     |     |   600
+(301 rows)
+
+SELECT * FROM test_gs1 ORDER BY x, y, z;
+  x  |  y  |  z   | count 
+-----+-----+------+-------
+   1 |   2 |   -1 |     6
+   2 |   4 |   -2 |     6
+   3 |   6 |   -3 |     6
+   4 |   8 |   -4 |     6
+   5 |  10 |   -5 |     6
+   6 |  12 |   -6 |     6
+   7 |  14 |   -7 |     6
+   8 |  16 |   -8 |     6
+   9 |  18 |   -9 |     6
+  10 |  20 |  -10 |     6
+  11 |  22 |  -11 |     6
+  12 |  24 |  -12 |     6
+  13 |  26 |  -13 |     6
+  14 |  28 |  -14 |     6
+  15 |  30 |  -15 |     6
+  16 |  32 |  -16 |     6
+  17 |  34 |  -17 |     6
+  18 |  36 |  -18 |     6
+  19 |  38 |  -19 |     6
+  20 |  40 |  -20 |     6
+  21 |  42 |  -21 |     6
+  22 |  44 |  -22 |     6
+  23 |  46 |  -23 |     6
+  24 |  48 |  -24 |     6
+  25 |  50 |  -25 |     6
+  26 |  52 |  -26 |     6
+  27 |  54 |  -27 |     6
+  28 |  56 |  -28 |     6
+  29 |  58 |  -29 |     6
+  30 |  60 |  -30 |     6
+  31 |  62 |  -31 |     6
+  32 |  64 |  -32 |     6
+  33 |  66 |  -33 |     6
+  34 |  68 |  -34 |     6
+  35 |  70 |  -35 |     6
+  36 |  72 |  -36 |     6
+  37 |  74 |  -37 |     6
+  38 |  76 |  -38 |     6
+  39 |  78 |  -39 |     6
+  40 |  80 |  -40 |     6
+  41 |  82 |  -41 |     6
+  42 |  84 |  -42 |     6
+  43 |  86 |  -43 |     6
+  44 |  88 |  -44 |     6
+  45 |  90 |  -45 |     6
+  46 |  92 |  -46 |     6
+  47 |  94 |  -47 |     6
+  48 |  96 |  -48 |     6
+  49 |  98 |  -49 |     6
+  50 | 100 |  -50 |     6
+  51 | 102 |  -51 |     6
+  52 | 104 |  -52 |     6
+  53 | 106 |  -53 |     6
+  54 | 108 |  -54 |     6
+  55 | 110 |  -55 |     6
+  56 | 112 |  -56 |     6
+  57 | 114 |  -57 |     6
+  58 | 116 |  -58 |     6
+  59 | 118 |  -59 |     6
+  60 | 120 |  -60 |     6
+  61 | 122 |  -61 |     6
+  62 | 124 |  -62 |     6
+  63 | 126 |  -63 |     6
+  64 | 128 |  -64 |     6
+  65 | 130 |  -65 |     6
+  66 | 132 |  -66 |     6
+  67 | 134 |  -67 |     6
+  68 | 136 |  -68 |     6
+  69 | 138 |  -69 |     6
+  70 | 140 |  -70 |     6
+  71 | 142 |  -71 |     6
+  72 | 144 |  -72 |     6
+  73 | 146 |  -73 |     6
+  74 | 148 |  -74 |     6
+  75 | 150 |  -75 |     6
+  76 | 152 |  -76 |     6
+  77 | 154 |  -77 |     6
+  78 | 156 |  -78 |     6
+  79 | 158 |  -79 |     6
+  80 | 160 |  -80 |     6
+  81 | 162 |  -81 |     6
+  82 | 164 |  -82 |     6
+  83 | 166 |  -83 |     6
+  84 | 168 |  -84 |     6
+  85 | 170 |  -85 |     6
+  86 | 172 |  -86 |     6
+  87 | 174 |  -87 |     6
+  88 | 176 |  -88 |     6
+  89 | 178 |  -89 |     6
+  90 | 180 |  -90 |     6
+  91 | 182 |  -91 |     6
+  92 | 184 |  -92 |     6
+  93 | 186 |  -93 |     6
+  94 | 188 |  -94 |     6
+  95 | 190 |  -95 |     6
+  96 | 192 |  -96 |     6
+  97 | 194 |  -97 |     6
+  98 | 196 |  -98 |     6
+  99 | 198 |  -99 |     6
+ 100 | 200 | -100 |     6
+(100 rows)
+
+SELECT * FROM test_gs2 ORDER BY x, y;
+  x  |  y  | count 
+-----+-----+-------
+   1 |   2 |     6
+   2 |   4 |     6
+   3 |   6 |     6
+   4 |   8 |     6
+   5 |  10 |     6
+   6 |  12 |     6
+   7 |  14 |     6
+   8 |  16 |     6
+   9 |  18 |     6
+  10 |  20 |     6
+  11 |  22 |     6
+  12 |  24 |     6
+  13 |  26 |     6
+  14 |  28 |     6
+  15 |  30 |     6
+  16 |  32 |     6
+  17 |  34 |     6
+  18 |  36 |     6
+  19 |  38 |     6
+  20 |  40 |     6
+  21 |  42 |     6
+  22 |  44 |     6
+  23 |  46 |     6
+  24 |  48 |     6
+  25 |  50 |     6
+  26 |  52 |     6
+  27 |  54 |     6
+  28 |  56 |     6
+  29 |  58 |     6
+  30 |  60 |     6
+  31 |  62 |     6
+  32 |  64 |     6
+  33 |  66 |     6
+  34 |  68 |     6
+  35 |  70 |     6
+  36 |  72 |     6
+  37 |  74 |     6
+  38 |  76 |     6
+  39 |  78 |     6
+  40 |  80 |     6
+  41 |  82 |     6
+  42 |  84 |     6
+  43 |  86 |     6
+  44 |  88 |     6
+  45 |  90 |     6
+  46 |  92 |     6
+  47 |  94 |     6
+  48 |  96 |     6
+  49 |  98 |     6
+  50 | 100 |     6
+  51 | 102 |     6
+  52 | 104 |     6
+  53 | 106 |     6
+  54 | 108 |     6
+  55 | 110 |     6
+  56 | 112 |     6
+  57 | 114 |     6
+  58 | 116 |     6
+  59 | 118 |     6
+  60 | 120 |     6
+  61 | 122 |     6
+  62 | 124 |     6
+  63 | 126 |     6
+  64 | 128 |     6
+  65 | 130 |     6
+  66 | 132 |     6
+  67 | 134 |     6
+  68 | 136 |     6
+  69 | 138 |     6
+  70 | 140 |     6
+  71 | 142 |     6
+  72 | 144 |     6
+  73 | 146 |     6
+  74 | 148 |     6
+  75 | 150 |     6
+  76 | 152 |     6
+  77 | 154 |     6
+  78 | 156 |     6
+  79 | 158 |     6
+  80 | 160 |     6
+  81 | 162 |     6
+  82 | 164 |     6
+  83 | 166 |     6
+  84 | 168 |     6
+  85 | 170 |     6
+  86 | 172 |     6
+  87 | 174 |     6
+  88 | 176 |     6
+  89 | 178 |     6
+  90 | 180 |     6
+  91 | 182 |     6
+  92 | 184 |     6
+  93 | 186 |     6
+  94 | 188 |     6
+  95 | 190 |     6
+  96 | 192 |     6
+  97 | 194 |     6
+  98 | 196 |     6
+  99 | 198 |     6
+ 100 | 200 |     6
+(100 rows)
+
+SELECT * FROM test_gs3 ORDER BY x, y, z;
+  x  |  y  |  z   | count 
+-----+-----+------+-------
+   1 |     |      |     6
+   2 |     |      |     6
+   3 |     |      |     6
+   4 |     |      |     6
+   5 |     |      |     6
+   6 |     |      |     6
+   7 |     |      |     6
+   8 |     |      |     6
+   9 |     |      |     6
+  10 |     |      |     6
+  11 |     |      |     6
+  12 |     |      |     6
+  13 |     |      |     6
+  14 |     |      |     6
+  15 |     |      |     6
+  16 |     |      |     6
+  17 |     |      |     6
+  18 |     |      |     6
+  19 |     |      |     6
+  20 |     |      |     6
+  21 |     |      |     6
+  22 |     |      |     6
+  23 |     |      |     6
+  24 |     |      |     6
+  25 |     |      |     6
+  26 |     |      |     6
+  27 |     |      |     6
+  28 |     |      |     6
+  29 |     |      |     6
+  30 |     |      |     6
+  31 |     |      |     6
+  32 |     |      |     6
+  33 |     |      |     6
+  34 |     |      |     6
+  35 |     |      |     6
+  36 |     |      |     6
+  37 |     |      |     6
+  38 |     |      |     6
+  39 |     |      |     6
+  40 |     |      |     6
+  41 |     |      |     6
+  42 |     |      |     6
+  43 |     |      |     6
+  44 |     |      |     6
+  45 |     |      |     6
+  46 |     |      |     6
+  47 |     |      |     6
+  48 |     |      |     6
+  49 |     |      |     6
+  50 |     |      |     6
+  51 |     |      |     6
+  52 |     |      |     6
+  53 |     |      |     6
+  54 |     |      |     6
+  55 |     |      |     6
+  56 |     |      |     6
+  57 |     |      |     6
+  58 |     |      |     6
+  59 |     |      |     6
+  60 |     |      |     6
+  61 |     |      |     6
+  62 |     |      |     6
+  63 |     |      |     6
+  64 |     |      |     6
+  65 |     |      |     6
+  66 |     |      |     6
+  67 |     |      |     6
+  68 |     |      |     6
+  69 |     |      |     6
+  70 |     |      |     6
+  71 |     |      |     6
+  72 |     |      |     6
+  73 |     |      |     6
+  74 |     |      |     6
+  75 |     |      |     6
+  76 |     |      |     6
+  77 |     |      |     6
+  78 |     |      |     6
+  79 |     |      |     6
+  80 |     |      |     6
+  81 |     |      |     6
+  82 |     |      |     6
+  83 |     |      |     6
+  84 |     |      |     6
+  85 |     |      |     6
+  86 |     |      |     6
+  87 |     |      |     6
+  88 |     |      |     6
+  89 |     |      |     6
+  90 |     |      |     6
+  91 |     |      |     6
+  92 |     |      |     6
+  93 |     |      |     6
+  94 |     |      |     6
+  95 |     |      |     6
+  96 |     |      |     6
+  97 |     |      |     6
+  98 |     |      |     6
+  99 |     |      |     6
+ 100 |     |      |     6
+     |   2 |      |     6
+     |   4 |      |     6
+     |   6 |      |     6
+     |   8 |      |     6
+     |  10 |      |     6
+     |  12 |      |     6
+     |  14 |      |     6
+     |  16 |      |     6
+     |  18 |      |     6
+     |  20 |      |     6
+     |  22 |      |     6
+     |  24 |      |     6
+     |  26 |      |     6
+     |  28 |      |     6
+     |  30 |      |     6
+     |  32 |      |     6
+     |  34 |      |     6
+     |  36 |      |     6
+     |  38 |      |     6
+     |  40 |      |     6
+     |  42 |      |     6
+     |  44 |      |     6
+     |  46 |      |     6
+     |  48 |      |     6
+     |  50 |      |     6
+     |  52 |      |     6
+     |  54 |      |     6
+     |  56 |      |     6
+     |  58 |      |     6
+     |  60 |      |     6
+     |  62 |      |     6
+     |  64 |      |     6
+     |  66 |      |     6
+     |  68 |      |     6
+     |  70 |      |     6
+     |  72 |      |     6
+     |  74 |      |     6
+     |  76 |      |     6
+     |  78 |      |     6
+     |  80 |      |     6
+     |  82 |      |     6
+     |  84 |      |     6
+     |  86 |      |     6
+     |  88 |      |     6
+     |  90 |      |     6
+     |  92 |      |     6
+     |  94 |      |     6
+     |  96 |      |     6
+     |  98 |      |     6
+     | 100 |      |     6
+     | 102 |      |     6
+     | 104 |      |     6
+     | 106 |      |     6
+     | 108 |      |     6
+     | 110 |      |     6
+     | 112 |      |     6
+     | 114 |      |     6
+     | 116 |      |     6
+     | 118 |      |     6
+     | 120 |      |     6
+     | 122 |      |     6
+     | 124 |      |     6
+     | 126 |      |     6
+     | 128 |      |     6
+     | 130 |      |     6
+     | 132 |      |     6
+     | 134 |      |     6
+     | 136 |      |     6
+     | 138 |      |     6
+     | 140 |      |     6
+     | 142 |      |     6
+     | 144 |      |     6
+     | 146 |      |     6
+     | 148 |      |     6
+     | 150 |      |     6
+     | 152 |      |     6
+     | 154 |      |     6
+     | 156 |      |     6
+     | 158 |      |     6
+     | 160 |      |     6
+     | 162 |      |     6
+     | 164 |      |     6
+     | 166 |      |     6
+     | 168 |      |     6
+     | 170 |      |     6
+     | 172 |      |     6
+     | 174 |      |     6
+     | 176 |      |     6
+     | 178 |      |     6
+     | 180 |      |     6
+     | 182 |      |     6
+     | 184 |      |     6
+     | 186 |      |     6
+     | 188 |      |     6
+     | 190 |      |     6
+     | 192 |      |     6
+     | 194 |      |     6
+     | 196 |      |     6
+     | 198 |      |     6
+     | 200 |      |     6
+     |     | -100 |     6
+     |     |  -99 |     6
+     |     |  -98 |     6
+     |     |  -97 |     6
+     |     |  -96 |     6
+     |     |  -95 |     6
+     |     |  -94 |     6
+     |     |  -93 |     6
+     |     |  -92 |     6
+     |     |  -91 |     6
+     |     |  -90 |     6
+     |     |  -89 |     6
+     |     |  -88 |     6
+     |     |  -87 |     6
+     |     |  -86 |     6
+     |     |  -85 |     6
+     |     |  -84 |     6
+     |     |  -83 |     6
+     |     |  -82 |     6
+     |     |  -81 |     6
+     |     |  -80 |     6
+     |     |  -79 |     6
+     |     |  -78 |     6
+     |     |  -77 |     6
+     |     |  -76 |     6
+     |     |  -75 |     6
+     |     |  -74 |     6
+     |     |  -73 |     6
+     |     |  -72 |     6
+     |     |  -71 |     6
+     |     |  -70 |     6
+     |     |  -69 |     6
+     |     |  -68 |     6
+     |     |  -67 |     6
+     |     |  -66 |     6
+     |     |  -65 |     6
+     |     |  -64 |     6
+     |     |  -63 |     6
+     |     |  -62 |     6
+     |     |  -61 |     6
+     |     |  -60 |     6
+     |     |  -59 |     6
+     |     |  -58 |     6
+     |     |  -57 |     6
+     |     |  -56 |     6
+     |     |  -55 |     6
+     |     |  -54 |     6
+     |     |  -53 |     6
+     |     |  -52 |     6
+     |     |  -51 |     6
+     |     |  -50 |     6
+     |     |  -49 |     6
+     |     |  -48 |     6
+     |     |  -47 |     6
+     |     |  -46 |     6
+     |     |  -45 |     6
+     |     |  -44 |     6
+     |     |  -43 |     6
+     |     |  -42 |     6
+     |     |  -41 |     6
+     |     |  -40 |     6
+     |     |  -39 |     6
+     |     |  -38 |     6
+     |     |  -37 |     6
+     |     |  -36 |     6
+     |     |  -35 |     6
+     |     |  -34 |     6
+     |     |  -33 |     6
+     |     |  -32 |     6
+     |     |  -31 |     6
+     |     |  -30 |     6
+     |     |  -29 |     6
+     |     |  -28 |     6
+     |     |  -27 |     6
+     |     |  -26 |     6
+     |     |  -25 |     6
+     |     |  -24 |     6
+     |     |  -23 |     6
+     |     |  -22 |     6
+     |     |  -21 |     6
+     |     |  -20 |     6
+     |     |  -19 |     6
+     |     |  -18 |     6
+     |     |  -17 |     6
+     |     |  -16 |     6
+     |     |  -15 |     6
+     |     |  -14 |     6
+     |     |  -13 |     6
+     |     |  -12 |     6
+     |     |  -11 |     6
+     |     |  -10 |     6
+     |     |   -9 |     6
+     |     |   -8 |     6
+     |     |   -7 |     6
+     |     |   -6 |     6
+     |     |   -5 |     6
+     |     |   -4 |     6
+     |     |   -3 |     6
+     |     |   -2 |     6
+     |     |   -1 |     6
+(300 rows)
+
+SELECT pg_sleep(5);
+ pg_sleep 
+----------
+ 
+(1 row)
+
+SELECT * FROM test_gs3 ORDER BY x, y, z;
+ x | y | z | count 
+---+---+---+-------
+(0 rows)
+
+DROP CONTINUOUS VIEW test_gs0;
+DROP CONTINUOUS VIEW test_gs1;
+DROP CONTINUOUS VIEW test_gs2;
+DROP CONTINUOUS VIEW test_gs3;
diff --git a/src/test/regress/parallel_schedule b/src/test/regress/parallel_schedule
index d19b36278..7aa2439c3 100644
--- a/src/test/regress/parallel_schedule
+++ b/src/test/regress/parallel_schedule
@@ -175,7 +175,7 @@ test: cont_view_namespace cont_complex_types cont_explain cont_multiple_sw keyed
 # ----------
 # Another group of parallel tests
 # ----------
-test: create_combinable_agg pipeline_regress cont_fss_agg cont_matrel cont_set_agg cont_index first_values
+test: create_combinable_agg pipeline_regress cont_fss_agg cont_matrel cont_set_agg cont_index first_values cont_grouping_sets
 
 # ----------
 # Another group of parallel tests
diff --git a/src/test/regress/sql/cont_grouping_sets.sql b/src/test/regress/sql/cont_grouping_sets.sql
new file mode 100644
index 000000000..de61a2328
--- /dev/null
+++ b/src/test/regress/sql/cont_grouping_sets.sql
@@ -0,0 +1,53 @@
+CREATE CONTINUOUS VIEW test_gs0 AS SELECT x::integer, y::integer, COUNT(*) FROM test_gs_stream
+	GROUP BY CUBE (x, y);
+
+SELECT pipeline_get_worker_querydef('test_gs0');
+SELECT pipeline_get_combiner_querydef('test_gs0');
+SELECT pipeline_get_overlay_viewdef('test_gs0');
+
+CREATE CONTINUOUS VIEW test_gs1 AS SELECT x::integer, y::integer, z::integer, COUNT(*) FROM test_gs_stream
+	GROUP BY GROUPING SETS (x), (x, y), (x, y, z), (x, z);
+
+SELECT pipeline_get_worker_querydef('test_gs1');
+SELECT pipeline_get_combiner_querydef('test_gs1');
+SELECT pipeline_get_overlay_viewdef('test_gs1');
+
+CREATE CONTINUOUS VIEW test_gs2 AS SELECT x::integer, y::integer, COUNT(*) FROM test_gs_stream
+	GROUP BY GROUPING SETS (x), (x, y);
+
+SELECT pipeline_get_worker_querydef('test_gs2');
+SELECT pipeline_get_combiner_querydef('test_gs2');
+SELECT pipeline_get_overlay_viewdef('test_gs2');
+
+CREATE CONTINUOUS VIEW test_gs3 WITH (max_age = '5 seconds') AS SELECT x::integer, y::integer, z::integer, COUNT(*) FROM test_gs_stream
+	GROUP BY GROUPING SETS (x, y, z);
+
+SELECT pipeline_get_worker_querydef('test_gs3');
+SELECT pipeline_get_combiner_querydef('test_gs3');
+SELECT pipeline_get_overlay_viewdef('test_gs3');
+
+INSERT INTO test_gs_stream (x, y, z) SELECT x, x * 2 AS y, -x AS z FROM generate_series(1, 100) AS x;
+INSERT INTO test_gs_stream (x, y, z) SELECT x, x * 2 AS y, -x AS z FROM generate_series(1, 100) AS x;
+INSERT INTO test_gs_stream (x, y, z) SELECT x, x * 2 AS y, -x AS z FROM generate_series(1, 100) AS x;
+
+SELECT * FROM test_gs0 ORDER BY x, y;
+SELECT * FROM test_gs1 ORDER BY x, y, z;
+SELECT * FROM test_gs2 ORDER BY x, y;
+SELECT * FROM test_gs3 ORDER BY x, y, z;
+
+INSERT INTO test_gs_stream (x, y, z) SELECT x, x * 2 AS y, -x AS z FROM generate_series(1, 100) AS x;
+INSERT INTO test_gs_stream (x, y, z) SELECT x, x * 2 AS y, -x AS z FROM generate_series(1, 100) AS x;
+INSERT INTO test_gs_stream (x, y, z) SELECT x, x * 2 AS y, -x AS z FROM generate_series(1, 100) AS x;
+
+SELECT * FROM test_gs0 ORDER BY x, y;
+SELECT * FROM test_gs1 ORDER BY x, y, z;
+SELECT * FROM test_gs2 ORDER BY x, y;
+SELECT * FROM test_gs3 ORDER BY x, y, z;
+
+SELECT pg_sleep(5);
+SELECT * FROM test_gs3 ORDER BY x, y, z;
+
+DROP CONTINUOUS VIEW test_gs0;
+DROP CONTINUOUS VIEW test_gs1;
+DROP CONTINUOUS VIEW test_gs2;
+DROP CONTINUOUS VIEW test_gs3;
